#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <iostream>
using namespace std;

class Instrument {
public:
  virtual void play() {
    cout << "generic play" << endl;
  }
  virtual ~Instrument() { cout << " in ~Instrument()" << endl;   }
};

class Flute : public Instrument {
public:
  void play() {
    cout << "piririririiri!!!" << endl;
  }
  ~Flute() { cout << " in ~Flute()" << endl;   }
};

class Trombon : public Instrument {
public:
  void play() {
    cout << "bom bom bom bom bom " << endl;
  }
  ~Trombon() { cout << " in ~Trombon()" << endl;   }
};

class Triangulo : public Instrument {
public:
  void play() {
    cout << "chin chin chin chin chin " << endl;
  }
  ~Triangulo() { cout << " in ~Triangulo()" << endl;   }
};

int main() {
  int N=10;
  Instrument* v[N];
  for (int j=0; j<N; j++) {
    int r = j%3;
    if (r==0) v[j] = new Flute;
    else if (r==1) v[j] = new Trombon;
    else if (r==2) v[j] = new Triangulo;
  }

  for (int j=0; j<N; j++) v[j]->play();

  for (int j=0; j<N; j++) delete v[j];

  return 0;
}
